<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: alexaClientSDK::avsCommon::sdkInterfaces::DirectiveHandlerInterface Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common.html">avsCommon</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces.html">sdkInterfaces</a></li><li class="navelem"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_interface.html">DirectiveHandlerInterface</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_interface-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">alexaClientSDK::avsCommon::sdkInterfaces::DirectiveHandlerInterface Class Reference<span class="mlabels"><span class="mlabel">abstract</span></span></div>  </div>
</div><!--header-->
<div class="contents">

<p><code>#include &lt;<a class="el" href="_directive_handler_interface_8h_source.html">DirectiveHandlerInterface.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for alexaClientSDK::avsCommon::sdkInterfaces::DirectiveHandlerInterface:</div>
<div class="dyncontent">
<div class="center"><img src="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_interface__inherit__graph.png" border="0" usemap="#alexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_interface_inherit__map" alt="Inheritance graph"/></div>
<map name="alexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_interface_inherit__map" id="alexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_interface_inherit__map">
<area shape="rect" id="node2" href="classalexa_client_s_d_k_1_1adsl_1_1test_1_1_directive_handler_mock_adapter.html" title="alexaClientSDK::adsl\l::test::DirectiveHandlerMock\lAdapter" alt="" coords="278,276,466,328"/>
<area shape="rect" id="node4" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html" title="alexaClientSDK::avsCommon\l::avs::CapabilityAgent" alt="" coords="273,628,470,667"/>
<area shape="rect" id="node24" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1test_1_1_test_directive_handler.html" title="Minimal DirectiveHandlerInterface implementation so we can generate instance pointers. " alt="" coords="267,691,476,729"/>
<area shape="rect" id="node25" href="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler.html" title="alexaClientSDK::integration\l::test::TestDirectiveHandler" alt="" coords="280,753,464,792"/>
<area shape="rect" id="node3" href="classalexa_client_s_d_k_1_1adsl_1_1test_1_1_mock_directive_handler.html" title="alexaClientSDK::adsl\l::test::MockDirectiveHandler" alt="" coords="570,5,759,44"/>
<area shape="rect" id="node5" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_call_manager_interface.html" title="alexaClientSDK::avsCommon\l::sdkInterfaces::CallManagerInterface" alt="" coords="543,68,786,107"/>
<area shape="rect" id="node6" href="classalexa_client_s_d_k_1_1avs_common_1_1test_1_1_mock_capability_agent.html" title="alexaClientSDK::avsCommon\l::test::MockCapabilityAgent" alt="" coords="566,131,763,169"/>
<area shape="rect" id="node7" href="classalexa_client_s_d_k_1_1capability_agents_1_1aip_1_1_audio_input_processor.html" title="alexaClientSDK::capability\lAgents::aip::AudioInputProcessor" alt="" coords="555,193,774,232"/>
<area shape="rect" id="node8" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1_alerts_capability_agent.html" title="alexaClientSDK::capability\lAgents::alerts::AlertsCapabilityAgent" alt="" coords="546,256,783,295"/>
<area shape="rect" id="node9" href="classalexa_client_s_d_k_1_1capability_agents_1_1audio_player_1_1_audio_player.html" title="alexaClientSDK::capability\lAgents::audioPlayer::AudioPlayer" alt="" coords="555,319,775,357"/>
<area shape="rect" id="node10" href="classalexa_client_s_d_k_1_1capability_agents_1_1bluetooth_1_1_bluetooth.html" title="alexaClientSDK::capability\lAgents::bluetooth::Bluetooth" alt="" coords="570,381,759,420"/>
<area shape="rect" id="node11" href="classalexa_client_s_d_k_1_1capability_agents_1_1do_not_disturb_1_1_do_not_disturb_capability_agent.html" title="alexaClientSDK::capability\lAgents::doNotDisturb::DoNotDisturb\lCapabilityAgent" alt="" coords="547,444,782,496"/>
<area shape="rect" id="node12" href="classalexa_client_s_d_k_1_1capability_agents_1_1equalizer_1_1_equalizer_capability_agent.html" title="alexaClientSDK::capability\lAgents::equalizer::EqualizerCapabilityAgent" alt="" coords="524,520,805,559"/>
<area shape="rect" id="node13" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html" title="alexaClientSDK::capability\lAgents::externalMediaPlayer\l::ExternalMediaPlayer" alt="" coords="569,583,760,635"/>
<area shape="rect" id="node14" href="classalexa_client_s_d_k_1_1capability_agents_1_1interaction_model_1_1_interaction_model_capability_agent.html" title="alexaClientSDK::capability\lAgents::interactionModel\l::InteractionModelCapabilityAgent" alt="" coords="554,659,775,711"/>
<area shape="rect" id="node15" href="classalexa_client_s_d_k_1_1capability_agents_1_1mrm_1_1_m_r_m_capability_agent.html" title="alexaClientSDK::capability\lAgents::mrm::MRMCapabilityAgent" alt="" coords="550,735,779,773"/>
<area shape="rect" id="node16" href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notifications_capability_agent.html" title="alexaClientSDK::capability\lAgents::notifications::\lNotificationsCapabilityAgent" alt="" coords="571,797,758,849"/>
<area shape="rect" id="node17" href="classalexa_client_s_d_k_1_1capability_agents_1_1speaker_manager_1_1_speaker_manager.html" title="alexaClientSDK::capability\lAgents::speakerManager\l::SpeakerManager" alt="" coords="576,873,753,925"/>
<area shape="rect" id="node18" href="classalexa_client_s_d_k_1_1capability_agents_1_1speech_synthesizer_1_1_speech_synthesizer.html" title="alexaClientSDK::capability\lAgents::speechSynthesizer\l::SpeechSynthesizer" alt="" coords="573,949,756,1001"/>
<area shape="rect" id="node19" href="classalexa_client_s_d_k_1_1capability_agents_1_1system_1_1_endpoint_handler.html" title="alexaClientSDK::capability\lAgents::system::EndpointHandler" alt="" coords="555,1025,774,1064"/>
<area shape="rect" id="node20" href="classalexa_client_s_d_k_1_1capability_agents_1_1system_1_1_revoke_authorization_handler.html" title="alexaClientSDK::capability\lAgents::system::RevokeAuthorization\lHandler" alt="" coords="543,1088,786,1140"/>
<area shape="rect" id="node21" href="classalexa_client_s_d_k_1_1capability_agents_1_1system_1_1_software_info_sender.html" title="alexaClientSDK::capability\lAgents::system::SoftwareInfoSender" alt="" coords="546,1164,783,1203"/>
<area shape="rect" id="node22" href="classalexa_client_s_d_k_1_1capability_agents_1_1system_1_1_user_inactivity_monitor.html" title="This class implements a CapabilityAgent that handles the SetEndpoint directive. " alt="" coords="565,1227,764,1279"/>
<area shape="rect" id="node23" href="classalexa_client_s_d_k_1_1capability_agents_1_1template_runtime_1_1_template_runtime.html" title="alexaClientSDK::capability\lAgents::templateRuntime\l::TemplateRuntime" alt="" coords="576,1303,753,1355"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a0aa03b6867e8b6e44b8c1b8df93c2d5c"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_interface.html#a0aa03b6867e8b6e44b8c1b8df93c2d5c">~DirectiveHandlerInterface</a> ()=default</td></tr>
<tr class="separator:a0aa03b6867e8b6e44b8c1b8df93c2d5c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a517f1f6ceeba26da9dd071b9ad3dc390"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_interface.html#a517f1f6ceeba26da9dd071b9ad3dc390">handleDirectiveImmediately</a> (std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html">avsCommon::avs::AVSDirective</a> &gt; directive)=0</td></tr>
<tr class="separator:a517f1f6ceeba26da9dd071b9ad3dc390"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9bfec681151c104a12274fde87ff507d"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_interface.html#a9bfec681151c104a12274fde87ff507d">preHandleDirective</a> (std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html">avsCommon::avs::AVSDirective</a> &gt; directive, std::unique_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_result_interface.html">DirectiveHandlerResultInterface</a> &gt; result)=0</td></tr>
<tr class="separator:a9bfec681151c104a12274fde87ff507d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa3de8075443d7a91320405946556c853"><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_interface.html#aa3de8075443d7a91320405946556c853">handleDirective</a> (const std::string &amp;messageId)=0</td></tr>
<tr class="separator:aa3de8075443d7a91320405946556c853"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7b70eacac868a59404cd2cbde1489f31"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_interface.html#a7b70eacac868a59404cd2cbde1489f31">cancelDirective</a> (const std::string &amp;messageId)=0</td></tr>
<tr class="separator:a7b70eacac868a59404cd2cbde1489f31"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aad30d3ffcd120787b94799b2009e3369"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_interface.html#aad30d3ffcd120787b94799b2009e3369">onDeregistered</a> ()=0</td></tr>
<tr class="separator:aad30d3ffcd120787b94799b2009e3369"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9a4151577d823b1e991af340c233441b"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#a2c1f3500cf37d70ffd6c1067f9c7f921">avs::DirectiveHandlerConfiguration</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_interface.html#a9a4151577d823b1e991af340c233441b">getConfiguration</a> () const =0</td></tr>
<tr class="separator:a9a4151577d823b1e991af340c233441b"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p class="">Interface for handling <code>AVSDirectives</code>. For each <code>AVSDirective</code> received, implementations of this interface should expect either a single call to <code><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_interface.html#a517f1f6ceeba26da9dd071b9ad3dc390">handleDirectiveImmediately()</a></code> or a call to <code><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_interface.html#a9bfec681151c104a12274fde87ff507d">preHandleDirective()</a></code> followed by a call to <code><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_interface.html#aa3de8075443d7a91320405946556c853">handleDirective()</a></code> unless <code><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_interface.html#a7b70eacac868a59404cd2cbde1489f31">cancelDirective()</a></code> is called first. <code><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_interface.html#a7b70eacac868a59404cd2cbde1489f31">cancelDirective()</a></code> may also be called after <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_interface.html#aa3de8075443d7a91320405946556c853">handleDirective()</a>.</p>
<dl class="section note"><dt>Note</dt><dd>The implementation of the methods of this interface MUST be thread-safe. </dd>
<dd>
The implementation of the methods of this interface MUST return quickly. Failure to do so blocks the processing of subsequent <code>AVSDirectives</code>. </dd></dl>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a0aa03b6867e8b6e44b8c1b8df93c2d5c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0aa03b6867e8b6e44b8c1b8df93c2d5c">&#9670;&nbsp;</a></span>~DirectiveHandlerInterface()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual alexaClientSDK::avsCommon::sdkInterfaces::DirectiveHandlerInterface::~DirectiveHandlerInterface </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span><span class="mlabel">default</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Destructor. </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a7b70eacac868a59404cd2cbde1489f31"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7b70eacac868a59404cd2cbde1489f31">&#9670;&nbsp;</a></span>cancelDirective()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void alexaClientSDK::avsCommon::sdkInterfaces::DirectiveHandlerInterface::cancelDirective </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>messageId</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Cancel an ongoing <code><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_interface.html#a9bfec681151c104a12274fde87ff507d">preHandleDirective()</a></code> or <code><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_interface.html#aa3de8075443d7a91320405946556c853">handleDirective()</a></code> operation for the specified <code>AVSDirective</code>. Once this has been called the <code>DirectiveHandler</code> should not expect to receive further calls regarding this directive.</p>
<dl class="section note"><dt>Note</dt><dd>The implementation of this method MUST be thread-safe. </dd>
<dd>
The implementation of this method MUST return quickly. Failure to do so blocks the processing of subsequent <code>AVSDirectives</code>.</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">messageId</td><td>The message ID of a directive previously passed to <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_interface.html#a9bfec681151c104a12274fde87ff507d">preHandleDirective()</a>. </td></tr>
  </table>
  </dd>
</dl>

<p>Implemented in <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#a3840603cf5c461f2e13b61cbab0e3e90">alexaClientSDK::avsCommon::avs::CapabilityAgent</a>, <a class="el" href="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler.html#a346a60af43ec62960dd1da7bd0d9576f">alexaClientSDK::integration::test::TestDirectiveHandler</a>, and <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1test_1_1_test_directive_handler.html#aaee66095b476f1d139eafd6514240324">alexaClientSDK::avsCommon::avs::test::TestDirectiveHandler</a>.</p>

</div>
</div>
<a id="a9a4151577d823b1e991af340c233441b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9a4151577d823b1e991af340c233441b">&#9670;&nbsp;</a></span>getConfiguration()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#a2c1f3500cf37d70ffd6c1067f9c7f921">avs::DirectiveHandlerConfiguration</a> alexaClientSDK::avsCommon::sdkInterfaces::DirectiveHandlerInterface::getConfiguration </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Returns the configuration of the directive handler regarding which namespace and name pairs it should handle and the appropriate policy for each pair.</p>
<dl class="section return"><dt>Returns</dt><dd>The <code><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#a2c1f3500cf37d70ffd6c1067f9c7f921">avs::DirectiveHandlerConfiguration</a></code> of the handler. </dd></dl>

<p>Implemented in <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1test_1_1_mock_capability_agent.html#a4662e55461bef424944ba1bfc01b4acd">alexaClientSDK::avsCommon::test::MockCapabilityAgent</a>, <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1aip_1_1_audio_input_processor.html#ae3fc27ae8b25b0bbf7bcb32e4e84495c">alexaClientSDK::capabilityAgents::aip::AudioInputProcessor</a>, <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1bluetooth_1_1_bluetooth.html#a1649a9e419f46971dc33c89954de3038">alexaClientSDK::capabilityAgents::bluetooth::Bluetooth</a>, <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#ae6c3e74940d288662ca3c28273b1e297">alexaClientSDK::capabilityAgents::externalMediaPlayer::ExternalMediaPlayer</a>, <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notifications_capability_agent.html#ac28bede5788dcf4111637673ee56a48c">alexaClientSDK::capabilityAgents::notifications::NotificationsCapabilityAgent</a>, <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1_alerts_capability_agent.html#a371c535e0e1838573bdba6fcf6a4a396">alexaClientSDK::capabilityAgents::alerts::AlertsCapabilityAgent</a>, <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1audio_player_1_1_audio_player.html#a3324b9202c2310c5cc151780ef0902a6">alexaClientSDK::capabilityAgents::audioPlayer::AudioPlayer</a>, <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1template_runtime_1_1_template_runtime.html#a36a63eab9d6b4b9245ba9fef64e0535b">alexaClientSDK::capabilityAgents::templateRuntime::TemplateRuntime</a>, <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1do_not_disturb_1_1_do_not_disturb_capability_agent.html#a720a461e59d1bc5a4fdf744f6f754e0a">alexaClientSDK::capabilityAgents::doNotDisturb::DoNotDisturbCapabilityAgent</a>, <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1equalizer_1_1_equalizer_capability_agent.html#aa1578f5242c293a30970b2bceb7de2b1">alexaClientSDK::capabilityAgents::equalizer::EqualizerCapabilityAgent</a>, <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1speech_synthesizer_1_1_speech_synthesizer.html#aa21feeb9eb3c6b74178def197b36f699">alexaClientSDK::capabilityAgents::speechSynthesizer::SpeechSynthesizer</a>, <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1system_1_1_software_info_sender.html#a2544e548ecdc780837d71b39080ac247">alexaClientSDK::capabilityAgents::system::SoftwareInfoSender</a>, <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1mrm_1_1_m_r_m_capability_agent.html#a9ea20cebdadc12be68e4133333ea5474">alexaClientSDK::capabilityAgents::mrm::MRMCapabilityAgent</a>, <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1speaker_manager_1_1_speaker_manager.html#a31a2e9278c0505fc9316e251364a1a3c">alexaClientSDK::capabilityAgents::speakerManager::SpeakerManager</a>, <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1interaction_model_1_1_interaction_model_capability_agent.html#af40671f4fe9e51887ed2859e26eb50fc">alexaClientSDK::capabilityAgents::interactionModel::InteractionModelCapabilityAgent</a>, <a class="el" href="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler.html#ae57d7a034ddc63d63dec5d7a52c14ee4">alexaClientSDK::integration::test::TestDirectiveHandler</a>, <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1system_1_1_user_inactivity_monitor.html#aadfa63b951870901ca955b79efb2fb2c">alexaClientSDK::capabilityAgents::system::UserInactivityMonitor</a>, <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1system_1_1_revoke_authorization_handler.html#aad7a6b766d0aaa56b6ea1239800b25d2">alexaClientSDK::capabilityAgents::system::RevokeAuthorizationHandler</a>, <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1system_1_1_endpoint_handler.html#abbb4136c7b2a2a0936d699cc88566ea4">alexaClientSDK::capabilityAgents::system::EndpointHandler</a>, and <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1test_1_1_test_directive_handler.html#ad053a0352135ed7d101c6b81dfd968c5">alexaClientSDK::avsCommon::avs::test::TestDirectiveHandler</a>.</p>

</div>
</div>
<a id="aa3de8075443d7a91320405946556c853"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa3de8075443d7a91320405946556c853">&#9670;&nbsp;</a></span>handleDirective()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool alexaClientSDK::avsCommon::sdkInterfaces::DirectiveHandlerInterface::handleDirective </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>messageId</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Handle the action specified by the directive identified by <code>messageId</code>. The handling of subsequent directives with the same <code>DialogRequestId</code> may be blocked until the <code>DirectiveHandler</code> calls the <code>setSucceeded()</code> method of the <code>DirectiveHandlingResult</code> instance passed in to the <code><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_interface.html#a9bfec681151c104a12274fde87ff507d">preHandleDirective()</a></code> call for the directive specified by <code>messageId</code>. If handling of this directive fails such that subsequent directives with the same <code>DialogRequestId</code> should be cancelled, this <code>DirectiveHandler</code> should instead call setFailed() to indicate a failure.</p>
<dl class="section note"><dt>Note</dt><dd>If this operation fails, an <code>ExceptionEncountered</code> message should be sent to AVS. </dd>
<dd>
The implementation of this method MUST be thread-safe. </dd>
<dd>
The implementation of this method MUST return quickly. Failure to do so blocks the processing of subsequent <code>AVSDirectives</code>.</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">messageId</td><td>The message ID of a directive previously passed to <code><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_interface.html#a9bfec681151c104a12274fde87ff507d">preHandleDirective()</a></code>. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd><code>false</code> when <code>messageId</code> is not recognized, else <code>true</code>. Any errors related to handling of a valid messageId should be reported using <code><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_result_interface.html#add0024d48a616a54fc33fcf3b20be26a">DirectiveHandlerResultInterface::setFailed()</a></code>. </dd></dl>

<p>Implemented in <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#a971352c6a79f7cb000e5e632648bceb3">alexaClientSDK::avsCommon::avs::CapabilityAgent</a>, <a class="el" href="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler.html#af0a455b5c8d54500304918980402cd31">alexaClientSDK::integration::test::TestDirectiveHandler</a>, and <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1test_1_1_test_directive_handler.html#aae40f8853a64f29c0f9ed3af96de3691">alexaClientSDK::avsCommon::avs::test::TestDirectiveHandler</a>.</p>

</div>
</div>
<a id="a517f1f6ceeba26da9dd071b9ad3dc390"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a517f1f6ceeba26da9dd071b9ad3dc390">&#9670;&nbsp;</a></span>handleDirectiveImmediately()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void alexaClientSDK::avsCommon::sdkInterfaces::DirectiveHandlerInterface::handleDirectiveImmediately </td>
          <td>(</td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html">avsCommon::avs::AVSDirective</a> &gt;&#160;</td>
          <td class="paramname"><em>directive</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Handle the action specified <code>AVSDirective</code>. Once this has been called the <code>DirectiveHandler</code> should not expect to receive further calls regarding this directive.</p>
<dl class="section note"><dt>Note</dt><dd>The implementation of this method MUST be thread-safe. </dd>
<dd>
The implementation of this method MUST return quickly. Failure to do so blocks the processing of subsequent <code>AVSDirectives</code>. </dd>
<dd>
If this operation fails, an <code>ExceptionEncountered</code> message should be sent to AVS.</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">directive</td><td>The directive to handle. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="aad30d3ffcd120787b94799b2009e3369"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aad30d3ffcd120787b94799b2009e3369">&#9670;&nbsp;</a></span>onDeregistered()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void alexaClientSDK::avsCommon::sdkInterfaces::DirectiveHandlerInterface::onDeregistered </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Notification that this handler has been de-registered and will not receive any more calls. </p>

<p>Implemented in <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1aip_1_1_audio_input_processor.html#af12e043cb4bb7190474ca6b3b77375ec">alexaClientSDK::capabilityAgents::aip::AudioInputProcessor</a>, <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#a00630efe454bba50a562505eb1457038">alexaClientSDK::capabilityAgents::externalMediaPlayer::ExternalMediaPlayer</a>, <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1_alerts_capability_agent.html#a78985125587bc62f4118ff949b197b6d">alexaClientSDK::capabilityAgents::alerts::AlertsCapabilityAgent</a>, <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1speech_synthesizer_1_1_speech_synthesizer.html#a735a44b3350e3d75338b9238030dbfaf">alexaClientSDK::capabilityAgents::speechSynthesizer::SpeechSynthesizer</a>, <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1audio_player_1_1_audio_player.html#a046345d67219c38ce74f5d2558072f81">alexaClientSDK::capabilityAgents::audioPlayer::AudioPlayer</a>, <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#a534b6a5c2280f9fcd0866a82524bbca4">alexaClientSDK::avsCommon::avs::CapabilityAgent</a>, <a class="el" href="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler.html#aeb89a15e4ed782296b5fb370a9b44f95">alexaClientSDK::integration::test::TestDirectiveHandler</a>, and <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1test_1_1_test_directive_handler.html#afc6425cf4990e97305d89d83928bfe3b">alexaClientSDK::avsCommon::avs::test::TestDirectiveHandler</a>.</p>

</div>
</div>
<a id="a9bfec681151c104a12274fde87ff507d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9bfec681151c104a12274fde87ff507d">&#9670;&nbsp;</a></span>preHandleDirective()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void alexaClientSDK::avsCommon::sdkInterfaces::DirectiveHandlerInterface::preHandleDirective </td>
          <td>(</td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html">avsCommon::avs::AVSDirective</a> &gt;&#160;</td>
          <td class="paramname"><em>directive</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::unique_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_result_interface.html">DirectiveHandlerResultInterface</a> &gt;&#160;</td>
          <td class="paramname"><em>result</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Notification that a directive has arrived. This notification gives the DirectiveHandler a chance to prepare for handling the directive. For example, the <code>DirectiveHandler</code> might use this notification to start downloading an asset that will be required when it becomes time to actually handle the directive. The <code>DirectiveHandler</code> will be notified when it should start the actual handling of the directive by a subsequent call to <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_interface.html#aa3de8075443d7a91320405946556c853">handleDirective()</a>. If an error occurs during the pre-Handling phase and that error should cancel the handling of subsequent <code>AVSDirectives</code> with the same <code>DialogRequestId</code>, the <code>DirectiveHandler</code> should call the setFailed() method on the <code>result</code> instance passed in to this call.</p>
<dl class="section note"><dt>Note</dt><dd>If this operation fails, an <code>ExceptionEncountered</code> message should be sent to AVS. </dd>
<dd>
The implementation of this method MUST be thread-safe. </dd>
<dd>
The implementation of this method MUST return quickly. Failure to do so blocks the processing of subsequent <code>AVSDirectives</code>.</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">directive</td><td>The directive to pre-handle. </td></tr>
    <tr><td class="paramname">result</td><td>An object to receive the result of the operation. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>/workplace/avs-device-sdk/AVSCommon/SDKInterfaces/include/AVSCommon/SDKInterfaces/<a class="el" href="_directive_handler_interface_8h_source.html">DirectiveHandlerInterface.h</a></li>
</ul>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
